/*
 * ***** BEGIN LICENSE BLOCK *****
 * 
 * Zimbra Collaboration Suite Web Client
 * Copyright (C) 2005, 2006, 2007 Zimbra, Inc.
 * 
 * The contents of this file are subject to the Yahoo! Public License
 * Version 1.0 ("License"); you may not use this file except in
 * compliance with the License.  You may obtain a copy of the License at
 * http://www.zimbra.com/license.
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.
  * 
  * ***** END LICENSE BLOCK *****
*/

/*
 * @author Daniel Eugenin M. <deugenin@it-linux.cl>
*/

DBG.println(AjxDebug.DBG1,"Loaded disclaimer.js");

function DisclaimerExtension() {}


ZaZimbraAdmin._DOMAIN_DISCLAIMER_VIEW = ZaZimbraAdmin.VIEW_INDEX++;
ZaZimbraAdmin.MSG_KEY[ZaZimbraAdmin._DOMAIN_DISCLAIMER_VIEW] = "DoXDisclaimer_view_title";

if(ZaMsg) {
        ZaMsg.DoXDisclaimer_view_title = "Manage Domain Disclaimer";
}

if(ZaItem) {
        ZaItem.DOMAIN_DISCLAIMER = "DomainDisclaimer";
}

function ZaDomainDisclaimer(app) {
        if (arguments.length == 0) return;
        ZaItem.call(this, app,"ZaDomainDisclaimer");
        this.type = ZaItem.DOMAIN_DISCLAIMER;
        this.attrs = [];
        this._init(app);
}

ZaDomainDisclaimer.prototype = new ZaItem;
ZaDomainDisclaimer.prototype.constructor = ZaDomainDisclaimer;

// LDAP Attributes definition
ZaDomainDisclaimer.A_zimbraDomainPrefMailSignatureEnabled = "zimbraDomainPrefMailSignatureEnabled";
ZaDomainDisclaimer.A_zimbraDomainPrefMailSignature = "zimbraDomainPrefMailSignature";
ZaDomainDisclaimer.A_zimbraDomainPrefMailSignatureHTML = "zimbraDomainPrefMailSignatureHTML";

// Add my new LDAP attrributes to ZaDomain.myXModel
if(ZaDomain.myXModel && ZaDomain.myXModel.items) {
        ZaDomain.myXModel.items.push({id:ZaDomainDisclaimer.A_zimbraDomainPrefMailSignatureEnabled, type:_ENUM_, choices:ZaModel.BOOLEAN_CHOICES, ref:"attrs/"+ZaDomainDisclaimer.A_zimbraDomainPrefMailSignatureEnabled});
	ZaDomain.myXModel.items.push({id:ZaDomainDisclaimer.A_zimbraDomainPrefMailSignature, type:_STRING_, ref:"attrs/"+ZaDomainDisclaimer.A_zimbraDomainPrefMailSignature});
	ZaDomain.myXModel.items.push({id:ZaDomainDisclaimer.A_zimbraDomainPrefMailSignatureHTML, type:_STRING_, ref:"attrs/"+ZaDomainDisclaimer.A_zimbraDomainPrefMailSignatureHTML});
}

// check if attribute "zimbraDomainPrefMailSignatureEnabled" is TRUE or FALSE
ZaDomainXFormView.iszimbraDomainPrefMailSignatureEnabled = function () {
        return (this.instance.attrs[ZaDomainDisclaimer.A_zimbraDomainPrefMailSignatureEnabled] == 'TRUE');
}


if(ZaTabView.XFormModifiers["ZaDomainXFormView"]) {
   DisclaimerExtension.DomainXFormModifier = function (xFormObject) {

	//find _TAB_BAR_ element
	var cnt = xFormObject.items.length;
        for(i = 0; i < cnt; i++) {
        	if(xFormObject.items[i].type=="tab_bar") break;
     	}
        //define a tab index
        var myTabIndex = 6;

        //add a tab
        xFormObject.items[i].choices.push({value:myTabIndex, label:"Disclaimer"});

        //define a form for my new tab.
        var myTab = 	{ type:_CASE_, relevant: ("instance[ZaModel.currentTab] == " + myTabIndex),
				items:[
					{ ref:ZaDomain.A_domainName, type:_OUTPUT_,
					  label:ZaMsg.Domain_DomainName
					},
					{ ref:ZaDomainDisclaimer.A_zimbraDomainPrefMailSignatureEnabled, type:_CHECKBOX_,
					  msgName:"Enabled",  label:"Enabled", trueValue:"TRUE", falseValue:"FALSE",
					  onChange:ZaTabView.onFormFieldChanged
					},
					{ ref:ZaDomainDisclaimer.A_zimbraDomainPrefMailSignature,
					  type:_TEXTAREA_, msgName:ZaDomainDisclaimer.A_zimbraDomainPrefMailSignature,
					  label:ZaDomainDisclaimer.A_zimbraDomainPrefMailSignature, labelLocation:_LEFT_,
					  labelCssStyle:"vertical-align:top", onChange:ZaTabView.onFormFieldChanged,
					  width:"30em",
					  relevant:"ZaDomainXFormView.iszimbraDomainPrefMailSignatureEnabled.call(this)",
					  relevantBehavior: _DISABLE_
					},
					{ ref:ZaDomainDisclaimer.A_zimbraDomainPrefMailSignatureHTML,
					  type:_TEXTAREA_, msgName:ZaDomainDisclaimer.A_zimbraDomainPrefMailSignatureHTML,
					  label:ZaDomainDisclaimer.A_zimbraDomainPrefMailSignatureHTML, labelLocation:_LEFT_,
					  labelCssStyle:"vertical-align:top", onChange:ZaTabView.onFormFieldChanged,
					  width:"30em",
					  relevant:"ZaDomainXFormView.iszimbraDomainPrefMailSignatureEnabled.call(this)",
					  relevantBehavior: _DISABLE_
					}
				]
	    		};

	//find SWITCH element
        for(i = 0; i < cnt; i++) {
		if(xFormObject.items[i].type=="switch") break;
      	}

        //add my tab to the form
        xFormObject.items[i].items.push(myTab);
   }

ZaTabView.XFormModifiers["ZaDomainXFormView"].push(DisclaimerExtension.DomainXFormModifier);

}

